ATTR:   equ 0x5cb0      ; Dirección atributo a aplicar al desplazar

Main:
ld      b, 0x20         ; B = 32 desplazamientos

LoopL:
push    bc              ; Preserva BC
ld      b, 0x16         ; B = 22 líneas
ld      hl, 0x4000      ; HL = línea 0, columna 0, scanline 0
loopL_line:
push    bc              ; Preserva BC
push    hl              ; Preserva HL
ld      b, 0x08         ; B = 8 scanlines
loopL_scan:
push    bc              ; Preserva BC
push    hl              ; Preserva HL
ld      d, h            ; D = H
ld      e, l            ; E = L
inc     l               ; HL = columna 1
ld      bc, 0x1f        ; BC = 31 columnas
ldir                    ; Desplaza 31 columnas
dec     hl              ; HL = columna 31
ld      (hl), 0x00      ; Limpia columna 31
pop     hl              ; Recupera HL
pop     bc              ; Recupera BC, scanlines
inc     h               ; HL = siguiente scanline
djnz    loopL_scan      ; Bucle hasta recorrer 8 scanlines
loopL_attr:
pop     hl              ; Recupera HL
push    hl              ; Preserva HL
ld      a, h            ; A = H, 010TTSSS
and     0x18            ; A = 000TT000
rra
rra
rra                     ; A = 000000TT
or      0x58            ; A = 010110TT, dirección base atributos
ld      h, a            ; H = A
ld      d, h            ; D = H
ld      e, l            ; E = L
inc     l               ; HL = columna 1
ld      bc, 0x1f        ; BC = 31 columnas
ldir                    ; Desplaza atributos     
dec     hl              ; HL = columna 31             
ld      a, (ATTR)       ; A = atributo que limpia
ld      (hl), a         ; Limpia atributo columna 31
loopL_nextLine:    
pop     hl              ; Recupera HL
pop     bc              ; Recupera BC, líneas
ld      a, l            ; A = L, línea
add     a, 0x20         ; A+= 1 línea
ld      l, a            ; L = línea siguiente
jr      nc, loopL_cont  ; ¿Acarreo? No, salta
ld      a, h            ; A = HL
add     a, 0x08         ; A+= 1 tercio
ld      h, a            ; H = tercio siguiente
loopL_cont:
djnz    loopL_line      ; Bucle hasta recorrer 22 líneas


pop     bc              ; Recupera BC, desplazamientos
djnz    LoopL           ; Bucle hasta realizar 32 desplazamientos

ret                     ; Vuelve a Basic