ATTR:   equ 0x5cb0          ; Dirección atributo a aplicar al desplazar

Main:
ld      b, 0x20             ; B = 32 desplazamientos         

Loop:
push    bc                  ; Preserva BC
ld      b, 0x16             ; B = 22 líneas
ld      hl, 0x4000          ; HL = línea 0, columna 0, scanline 0
clear:
push    bc                  ; Preserva BC
push    hl                  ; Preserva HL
ld      e, 0x08             ; E = 8 scanlines

ld      a, b                ; A = línea
cp      0x0b                ; ¿Ha desplazado la mitad superior?
jr      c, clearL_scan      ; Si, salta

; Limpieza desplazando a la derecha
clearR_scan:
push    hl                  ; Preserva HL
push    de                  ; Preserva DE
ld      a, l                ; A = L
or      0x1f                ; A = columna 31 
ld      l, a                ; L = A
ld      d, h                ; D = H
ld      e, l                ; E = L
dec     l                   ; HL = columna 30
ld      bc, 0x1f            ; BC = 31 columnas
lddr                        ; Desplaza 31 columnas
inc     hl                  ; HL = columna 0
ld      (hl), 0x00          ; Limpia columna 0
pop     de                  ; Recupera DE, scanlines
pop     hl                  ; Recupera HL
inc     h                   ; HL = siguiente scanline
dec     e                   ; E-= 1
jr      nz, clearR_scan     ; Bucle hasta recorrer 8 scanlines
clearR_attr:
pop     hl                  ; Recupera HL
push    hl                  ; Preservar HL
ld      a, h                ; A = 010TTSSS
and     0x18                ; A = 000TT000
rra
rra
rra                         ; A = 000000TT
or      0x58                ; A = 010110TT (dirección base atributos)
ld      h, a                ; H = 010110TT
ld      d, h                ; D = H
ld      a, l                ; A = L
or      0x1f                ; A = columna 31
ld      l, a                ; L = columna 31
ld      e, l                ; E = L
dec     l                   ; HL = columna 30
ld      bc, 0x1f            ; BC = 31 columnas
lddr                        ; Desplaza 31 columnas
inc     hl                  ; HL = columna 0
ld      a, (ATTR)           ; A = atributo que limpia
ld      (hl), a             ; Limpia columna 0

jr      clear_nextLine      ; Siguiente línea
clear_int:
; Intermedio, el último JR no llega a Loop
jr      Loop                ; Loop

; Limpieza desplazando a la izquierda
clearL_scan:
push    hl                  ; Preserva HL
push    de                  ; Preserva DE
ld      d, h                ; D = H
ld      e, l                ; E = L
inc     l                   ; HL = columna 31
ld      bc, 0x1f            ; BC = 31 columnas
ldir                        ; Desplaza 31 columnas
dec     hl                  ; HL = columna 31
ld      (hl), 0x00          ; Limpia columna 31
pop     de                  ; Recupera DE, bucle scanlines
pop     hl                  ; Recupera HL
inc     h                   ; H+= 1, siguiente scanline
dec     e                   ; E-= 1
jr      nz, clearL_scan     ; Bucle hasta recorrer 8 scanlines
clearL_attr:
pop     hl                  ; Recupera HL
push    hl                  ; Preserva HL
ld      a, h                ; A = H, 010TTSSS
and     0x18                ; A = 000TT000
rra
rra
rra                         ; A = 000000TT
or      0x58                ; A = 010110TT
ld      h, a                ; H = A
ld      d, h                ; D = H
ld      e, l                ; E = L
inc     l                   ; L+= 1, HL = columna 1
ld      bc, 0x1f            ; BC = 31 columnas
ldir                        ; Desplaza 31 columnas
dec     hl                  ; HL-=1, HL = columna 31
ld      a, (ATTR)           ; A = atributo que limpia
ld      (hl), a             ; Limpia atributo columna 31

clear_nextLine:
pop     hl                  ; Recupera HL
ld      a, l                ; A = L, LLLCCCCC
and     0xe0                ; A = LLL00000
add     a, 0x20             ; A+= 1 línea
ld      l, a                ; L = A
jr      nc, clear_end       ; ¿Acarreo? No, salta
ld      a, h                ; A = H, 010TTSSS
add     a, 0x08             ; A+= 1 tercio
ld      h, a                ; H = tercio siguiente
clear_end:
pop     bc                  ; Recupera BC, bucle líneas
djnz    clear               ; Bucle hasta recorrer 22 líneas

pop     bc                  ; Recupera BC, bucle desplazamientos
djnz    clear_int           ; Bucle hasta realizar 32 desplazamientos

ret                         ; Vuelve a Basic