ATTR:   equ 0x5cb0      ; Dirección atributo a aplicar al desplazar

Main:
ld      b, 0x20         ; B = 32 desplazamientos

LoopR:
push    bc              ; Preserva BC
ld      b, 0x16         ; B = 22 líneas
ld      hl, 0x401f      ; HL = línea 0, columna 31, scanline 0
loopR_line:
push    bc              ; Preserva BC
push    hl              ; Preserva HL
ld      b, 0x08         ; B = 8 scanlines
loopR_scan:
push    bc              ; Preserva BC
push    hl              ; Preserva HL
ld      d, h            ; D = H
ld      e, l            ; E = L
dec     l               ; HL = columna 30
ld      bc, 0x1f        ; BC = 31 columnas
lddr                    ; Desplaza 31 columnas
inc     hl              ; HL = columna 0
ld      (hl), 0x00      ; Limpia columna 0
pop     hl              ; Recupera HL
pop     bc              ; Recupera BC, scanlines
inc     h               ; HL = siguiente scanline
djnz    loopR_scan      ; Bucle hasta recorrer 8 scanlines
loopR_attr:
pop     hl              ; Recupera HL
push    hl              ; Preserva HL
ld      a, h            ; A = H, 010TTSSS
and     0x18            ; A = 000TT000
rra
rra
rra                     ; A = 000000TT
or      0x58            ; A = 010110TT, dirección base atributos
ld      h, a            ; H = A
ld      d, h            ; D = H
ld      e, l            ; E = L
dec     l               ; HL = columna 30
ld      bc, 0x1f        ; BC = 31 columnas
lddr                    ; Desplaza atributos     
inc     hl              ; HL = columna 0             
ld      a, (ATTR)       ; A = atributo que limpia
ld      (hl), a         ; Limpia atributo columna 0 
loopL_nextLine:    
pop     hl              ; Recupera HL
pop     bc              ; Recupera BC, líneas
ld      a, l            ; A = L, línea
add     a, 0x20         ; A+= 1 línea
ld      l, a            ; L = línea siguiente
jr      nc, loopR_cont  ; ¿Acarreo? No, salta
ld      a, h            ; A = HL
add     a, 0x08         ; A+= 1 tercio
ld      h, a            ; H = tercio siguiente
loopR_cont:
djnz    loopR_line      ; Bucle hasta recorrer 22 líneas


pop     bc              ; Recupera BC, desplazamientos
djnz    LoopR           ; Bucle hasta realizar 32 desplazamientos

ret                     ; Vuelve a Basic