Main:
ld      bc, 0x0100      ; B = 256 píxeles de ancho

LoopL:
push    bc              ; Preserva BC
ld      b, 0x16         ; B = 22 líneas
ld      hl, 0x4000      ; HL = línea 0, scanline 0, columna 0
loopL_line:
push    bc              ; Preserva BC
ld      b, 0x08         ; B = 8 scanlines * línea
push    hl              ; Perserva HL
loopL_scan:
push    bc              ; Preserva BC
ld      b, 0x20         ; B = 32 columnas * scanline
ld      a, l            ; A = L
or      0x1f            ; A = columna 31
ld      l, a            ; L = columna 31
loopL_col:
rl      (hl)            ; Rota izquierda
dec     l               ; L = columna anterior
djnz    loopL_col       ; Bucle hasta recorrer 32 columnas
loopL_scanEnd:
inc     l               ; L = columna siguiente
inc     h               ; H = siguiente scanline
pop     bc              ; Recupera BC (bucle scanline)
djnz    loopL_scan      ; Bucle hasta recorrer 8 scanlines
loopL_lineEnd:
pop     hl              ; Recupera HL (1er scanline línea)
ld      a, l            ; A = línea
add     a, 0x20         ; A+= 1 línea
ld      l, a            ; L = línea siguiente
jr      nc, loopL_end   ; ¿Acarreo? No, salta
ld      a, h            ; A = H
add     a, 0x08         ; A+= 1 tercio
ld      h, a            ; A = tercio siguiente
loopL_end:
pop     bc              ; Recupera BC (bucle línea)
djnz    loopL_line      ; Bucle hasta recorrer 12 líneas

Loop_end:
pop     bc              ; Recupera BC (bucle 0x0100)
dec     bc              ; BC-= 1
ld      a, b            ; A = B
or      c               ; ¿BC = 0?
jr      nz, LoopL       ; No, bucle

ret                     ; Vuelve a Basic