Main:
ld      bc, 0x0100      ; B = 256 píxeles de ancho

LoopR:
push    bc              ; Preserva BC
ld      b, 0x16         ; B = 22 líneas
ld      hl, 0x4000      ; HL = línea 0, columna 0
loopR_line:
push    bc              ; Preserva BC
ld      b, 0x08         ; B = 8 scanlines * línea
push    hl              ; Preserva BC
loopR_scan:
push    bc              ; Preserva BC
ld      b, 0x20         ; B = 32 columnas * scanline
ld      a, l            ; A = L
and     0xe0            ; A = línea
ld      l, a            ; L = línea
loopR_col:
rr      (hl)            ; Rota derecha
inc     l               ; L = columna siguiente
djnz    loopR_col       ; Bucle hasta recorrer 32 columnas
loopR_scanEnd:
dec     l               ; L = columna anterior
inc     h               ; H = scanline siguiente
pop     bc              ; Recupera BC (bucle scanlines)
djnz    loopR_scan      ; Bucle hasta recorrer 8 scanlines
loopR_lineEnd:
pop     hl              ; Recupera HL (1er scanline línea)
ld      a, l            ; A = L
add     a, 0x20         ; A+= 1 línea
ld      l, a            ; L = línea siguiente
jr      nc, loopR_end   ; ¿Acarreo? No, salta
ld      a, h            ; A = H
add     a, 0x08         ; A+= 1 tercio
ld      h, a            ; H = tercio siguiente
loopR_end:
pop     bc              ; Recupera BC (bucle líneas)
djnz    loopR_line      ; Bucle hasta recorrer 12 líneas

Loop_end:
pop     bc              ; Recupera BC (bucle 0x0100)
dec     bc              ; BC-= 1
ld      a, b            ; A = B
or      c               ; ¿BC = 0?
jr      nz, LoopR       ; No, bucle

ret                     ; Vuelve a Basic